#include "stm32f1xx_hal.h"
#include "gpio.h"
#include "spi.h"
#include "max6675.h"


uint8_t max6675ReadReg(uint16_t *reg) // Chip value return function
{
 
  HAL_StatusTypeDef hal_answer = HAL_ERROR; // Return Values Of HAL Functions
  
 
  uint8_t temp[2] = {0};  // Array for storing received data
  
  
  MAX6675_CS_SET();   // Enable chip
  
  
  hal_answer = HAL_SPI_Receive(MAX6675_SPI, temp, 2, 100);  // chip shadowing

  
  MAX6675_CS_RESET();  // Turn off chip
  
  if(hal_answer == HAL_OK) // Checking if the sensor is connected
  {
   
    if(temp[1] & 0x04) return MAX6675_ERROR;
   
    *reg = (uint16_t)(temp[1] >> 3);   // Convert received data
    *reg |= (uint16_t)(temp[0] << 5);
    
    return MAX6675_OK;
  }
  
  return MAX6675_ERROR;
}


float max6675Temp(uint16_t reg) // Convert received data to temperature
{
  return reg * 0.25;
}
